## tomopy 1.15.2+ds1

=== CMakeLists.txt ===
# -------------------------------------------------------------------------------------- #
# cmake settings
#
cmake_minimum_required(VERSION 3.8...3.26)
if(${CMAKE_VERSION} VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()

# Warn about an in-source build, but don't error out
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message(STATUS "Warning! Building from the source directory is not recommended")
    message(STATUS "If unintented, please remove 'CMakeCache.txt' and 'CMakeFiles'")
    message(STATUS "and build from a separate directory")
    message(WARNING "In-source build")
endif()

# Check if project is being used directly or via add_subdirectory
set(PTL_MASTER_PROJECT ON)
if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(PTL_MASTER_PROJECT OFF)
else()
    set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
endif()

# Version
file(READ "${CMAKE_CURRENT_LIST_DIR}/VERSION" VERSION_STRING LIMIT_COUNT 1)
string(REGEX REPLACE "(\n|\r)" "" VERSION_STRING "${VERSION_STRING}")
string(REGEX REPLACE "[A-Za-z].*" "" VERSION_STRING "${VERSION_STRING}")
set(PTL_VERSION "${VERSION_STRING}")

# -------------------------------------------------------------------------------------- #
# -------------------------------------------------------------------------------------- #
# project setup
#
project(
    PTL
    LANGUAGES C CXX
    VERSION ${PTL_VERSION})

# Postprocess version info to create variables for export to Version.hh
set(PTL_VERSION_STRING "${PTL_VERSION_MAJOR}.${PTL_VERSION_MINOR}.${PTL_VERSION_PATCH}")
math(EXPR PTL_VERSION_CODE
     "10000 * ${PTL_VERSION_MAJOR} + 100 * ${PTL_VERSION_MINOR} + ${PTL_VERSION_PATCH}")

# Project-local CMake settings
set(CMAKE_DIRECTORY_LABELS "PTL")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)
set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME Development)
set(CMAKE_INSTALL_MESSAGE LAZY)
set(CMAKE_LINK_DEPENDS_NO_SHARED ON)
list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_CURRENT_LIST_DIR}/cmake/Modules)
include(PTLCMakeUtilities)

# -------------------------------------------------------------------------------------- #
# Build/Install settings and options
include(PTLInstallDirs)
include(PTLBuildSettings)

# -------------------------------------------------------------------------------------- #
# User options
ptl_add_option(PTL_USE_TBB "Enable TBB" ON)
ptl_add_option(PTL_USE_LOCKS "Enable mutex locking in task subqueues for extra safety"
               OFF)
ptl_add_option(PTL_INSTALL_HEADERS "Install the headers" ON)
ptl_add_option(PTL_INSTALL_CONFIG "Install the cmake configuration" ON)

if(DEFINED PTL_DEVELOPER_INSTALL)
    set(PTL_INSTALL_HEADERS
        ${PTL_DEVELOPER_INSTALL}
        CACHE BOOL "Set via PTL_DEVELOPER_INSTALL" FORCE)
    set(PTL_INSTALL_CONFIG
        ${PTL_DEVELOPER_INSTALL}
        CACHE BOOL "Set via PTL_DEVELOPER_INSTALL" FORCE)
endif()

# -------------------------------------------------------------------------------------- #
# Build Dependencies - Threads
if(NOT WIN32)
    set(CMAKE_THREAD_PREFER_PTHREAD ON)
    set(THREADS_PREFER_PTHREAD_FLAG ON)
endif()
find_package(Threads REQUIRED)

# * TBB
if(PTL_USE_TBB)
    find_package(TBB 2017 REQUIRED)
endif()

# Check if compiler provides std::atomic as a library
# Sets CXX_ATOMIC_WITH_LINK to TRUE if so
include(CheckAtomic)

# -------------------------------------------------------------------------------------- #
# PTL Primary Build
add_subdirectory(source)

# -------------------------------------------------------------------------------------- #
# CMake/PkgConfig Support files
include(PTLPackageConfigHelpers)

# -------------------------------------------------------------------------------------- #
# Examples build/test
if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/examples)
    ptl_add_option(PTL_BUILD_EXAMPLES "Build examples" OFF)
    if(PTL_BUILD_EXAMPLES)
        set(PTL_DIR ${CMAKE_BINARY_DIR})
        add_subdirectory(examples)
    endif()
endif()

# -------------------------------------------------------------------------------------- #
# Reporting if master project
if(PTL_MASTER_PROJECT)
    ptl_print_features()
endif()

=== examples/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# Setup the project
#
cmake_minimum_required(VERSION 3.8...3.20 FATAL_ERROR)
if(${CMAKE_VERSION} VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()
project(PTL_Examples)

if(CMAKE_CXX_COMPILER_ID MATCHES "(GNU|Clang|AppleClang)")
    string(APPEND CMAKE_CXX_FLAGS " -W -Wall")
endif()

find_package(PTL REQUIRED)

# add the common library Gperf and ittnotify options?
add_subdirectory(common)

# now the actual examples
add_subdirectory(minimal)
add_subdirectory(basic)
add_subdirectory(extended)

# Commenting as it can not currently compile add_subdirectory(gpu)

=== source/CMakeLists.txt ===
# -------------------------------------------------------------------------------------- #
# General
# -------------------------------------------------------------------------------------- #
# Locate sources and headers for this project - headers are included so they will show up
# in IDEs
file(GLOB_RECURSE ptl_headers ${CMAKE_CURRENT_LIST_DIR}/PTL/*.hh
     ${CMAKE_CURRENT_LIST_DIR}/PTL/detail/*.hh)
file(GLOB_RECURSE ptl_sources ${CMAKE_CURRENT_LIST_DIR}/*.cc)

# -------------------------------------------------------------------------------------- #
# Config, Version
# -------------------------------------------------------------------------------------- #

configure_file(${PROJECT_SOURCE_DIR}/cmake/Templates/Config.hh.in
               ${CMAKE_CURRENT_BINARY_DIR}/PTL/Config.hh @ONLY)

list(APPEND ptl_headers ${CMAKE_CURRENT_BINARY_DIR}/PTL/Config.hh)

configure_file(${PROJECT_SOURCE_DIR}/cmake/Templates/Version.hh.in
               ${CMAKE_CURRENT_BINARY_DIR}/PTL/Version.hh @ONLY)

list(APPEND ptl_headers ${CMAKE_CURRENT_BINARY_DIR}/PTL/Version.hh)

# -------------------------------------------------------------------------------------- #
# PTL Library
# -------------------------------------------------------------------------------------- #

if(BUILD_OBJECT_LIBS)

    ptl_build_library(
        TYPE OBJECT
        TARGET_NAME ptl-object
        OUTPUT_NAME ptl
        SOURCES ${ptl_headers} ${ptl_sources})

    target_link_libraries(ptl-object PUBLIC Threads::Threads)
    if(PTL_USE_TBB)
        target_link_libraries(ptl-object PUBLIC TBB::tbb)
    endif()
    if(CXX_ATOMIC_WITH_LINK)
        target_link_libraries(ptl-object PUBLIC atomic)
    endif()

    target_include_directories(
        ptl-object PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/source>
                          $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>)
endif()

if(BUILD_SHARED_LIBS)

    ptl_build_library(
        TYPE SHARED
        TARGET_NAME ptl-shared
        OUTPUT_NAME ptl
        SOURCES ${ptl_headers} ${ptl_sources})

    target_link_libraries(ptl-shared PUBLIC Threads::Threads)
    if(PTL_USE_TBB)
        target_link_libraries(ptl-shared PUBLIC TBB::tbb)
    endif()
    if(CXX_ATOMIC_WITH_LINK)
        target_link_libraries(ptl-shared PUBLIC atomic)
    endif()

    target_compile_definitions(ptl-shared PUBLIC PTL_BUILD_DLL)

    target_include_directories(
        ptl-shared
        PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/source>
               $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
               $<INSTALL_INTERFACE:${PTL_INSTALL_INCLUDEDIR}>)

    if(PTL_USE_SANITIZER AND NOT ("${PTL_SANITIZER_TYPE}" STREQUAL "leak"))
        string(REPLACE " " ";" _sanitize_args "${ptl_sanitize_args}")
        set_target_properties(ptl-shared PROPERTIES INTERFACE_LINK_OPTIONS
                                                    "${_sanitize_args}")
    endif()

    export(
        TARGETS ptl-shared
        NAMESPACE PTL::
        FILE ${PROJECT_BINARY_DIR}/ptl-shared.cmake)
endif()

if(BUILD_STATIC_LIBS)

    ptl_build_library(
        TYPE STATIC
        TARGET_NAME ptl-static
        OUTPUT_NAME ptl
        SOURCES ${ptl_headers} ${ptl_sources})

    target_link_libraries(ptl-static PUBLIC Threads::Threads)
    if(PTL_USE_TBB)
        target_link_libraries(ptl-static PUBLIC TBB::tbb)
    endif()
    if(CXX_ATOMIC_WITH_LINK)
        target_link_libraries(ptl-static PUBLIC atomic)
    endif()

    target_include_directories(
        ptl-static
        PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/source>
               $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
               $<INSTALL_INTERFACE:${PTL_INSTALL_INCLUDEDIR}>)

    export(
        TARGETS ptl-static
        NAMESPACE PTL::
        FILE ${PROJECT_BINARY_DIR}/ptl-static.cmake)
endif()

# -------------------------------------------------------------------------------------- #
# Installation
# -------------------------------------------------------------------------------------- #

if(PTL_INSTALL_CONFIG)
    # install export
    install(
        EXPORT ${PROJECT_NAME}Targets
        NAMESPACE PTL::
        DESTINATION ${PTL_INSTALL_CMAKEDIR}
        COMPONENT Development)
endif()

if(PTL_INSTALL_HEADERS)
    # headers - must use directory form due to nested structure
    install(
        DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/PTL ${CMAKE_CURRENT_BINARY_DIR}/PTL
        DESTINATION ${PTL_INSTALL_INCLUDEDIR}
        COMPONENT Development
        FILES_MATCHING
        PATTERN "*.hh")
endif()

=== examples/common/CMakeLists.txt ===
add_library(common STATIC utils.hh Backtrace.hh Timer.hh Timer.cc)
target_include_directories(common PUBLIC ${PROJECT_SOURCE_DIR})
target_link_libraries(common PUBLIC PTL::ptl)

=== examples/extended/CMakeLists.txt ===
# Subexamples
add_subdirectory(rotation)

=== examples/gpu/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# Setup the project
#
cmake_minimum_required(VERSION 3.1.3 FATAL_ERROR)
project(PTL_GPU_Examples LANGUAGES C CXX)

# ----------------------------------------------------------------------------
# Find PTL project
#
find_package(PTL REQUIRED)
set(EXTERNAL_INCLUDE_DIRS ${PTL_INCLUDE_DIRS})
set(EXTERNAL_LIBRARIES ${PTL_LIBRARIES})
include_directories(${EXTERNAL_INCLUDE_DIRS})
if(NOT DEFINED common_headers)
    get_filename_component(COMMON_DIR ${CMAKE_CURRENT_LIST_DIR} PATH)
    include_directories(${COMMON_DIR})
endif()

# ----------------------------------------------------------------------------
# Source files
#
file(GLOB headers ${CMAKE_CURRENT_LIST_DIR}/*.h ${CMAKE_CURRENT_LIST_DIR}/*.hh)

# ----------------------------------------------------------------------------
# CUDA
#
if(PTL_USE_CUDA)
    # ------------------------------------------------------------------------
    # Add the executable, and link it to the Tasking libraries
    #
    cuda_add_library(sum STATIC sum.cc sum.h sum.hh sum.cu)
    target_link_libraries(sum ${EXTERNAL_CUDA_LIBRARIES})

    cuda_add_executable(gpu_tasking gpu_tasking.cc ${headers})
    target_link_libraries(gpu_tasking sum ${EXTERNAL_LIBRARIES})
    set_target_properties(gpu_tasking PROPERTIES COMPILE_DEFINITIONS USE_CUDA_TASKS)
    install(TARGETS gpu_tasking DESTINATION bin)

    if(PTL_USE_TBB)
        add_executable(gpu_tbb_tasking gpu_tasking.cc ${headers})
        set_target_properties(gpu_tbb_tasking PROPERTIES COMPILE_DEFINITIONS
                                                         "USE_TBB_TASKS")
        target_link_libraries(gpu_tbb_tasking sum ${EXTERNAL_LIBRARIES})
        install(TARGETS gpu_tbb_tasking DESTINATION bin)
    endif(PTL_USE_TBB)

    # ------------------------------------------------------------------------
    # Install the executable to 'bin' directory under CMAKE_INSTALL_PREFIX
    #
endif()

=== examples/minimal/CMakeLists.txt ===
# ----------------------------------------------------------------------------
# minimal example
#
add_executable(ptl-minimal minimal.cc)
target_link_libraries(ptl-minimal PRIVATE PTL::ptl common)

=== source/libtomo/CMakeLists.txt ===
add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/misc)
add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/prep)
add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/recon)
add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/gridrec)
if(TOMOPY_USE_OPENCV OR TOMOPY_USE_CUDA)
  add_subdirectory(${CMAKE_CURRENT_LIST_DIR}/accel)
endif()

=== source/libtomo/accel/CMakeLists.txt ===
set(HEADERS "${tomopy_SOURCE_DIR}/include/libtomo/accel.h"
            "${tomopy_SOURCE_DIR}/include/libtomo/macros.h")

tomopy_add_library(
  tomo-accel
  SHARED
  cxx/common.cc
  cxx/mlem.cc
  cxx/sirt.cc
  common.hh
  constants.hh
  cuda.h
  data.hh
  macros.hh
  profiler.hh
  typedefs.hh
  utils.hh
  ${HEADERS})

target_include_directories(
  tomo-accel
  PUBLIC $<BUILD_INTERFACE:${tomopy_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE ${CMAKE_CURRENT_LIST_DIR})

if(TOMOPY_USE_CUDA)

  target_sources(tomo-accel PRIVATE gpu/common.cu gpu/mlem.cu gpu/sirt.cu
                                    gpu/utils.cu)

  target_include_directories(tomo-accel
                             PRIVATE ${CMAKE_CUDA_TOOLKIT_INCLUDE_DIRECTORIES})

  target_link_libraries(tomo-accel PRIVATE tomopy::cuda-npp)

  set(CUDA_PROPERTIES
      CUDA_STANDARD
      ${CMAKE_CXX_STANDARD}
      CUDA_STANDARD_REQUIRED
      ON
      CUDA_SEPARABLE_COMPILATION
      ON
      CUDA_RESOLVE_DEVICE_SYMBOLS
      ON)

  set_target_properties(tomo-accel PROPERTIES ${CUDA_PROPERTIES})

endif(TOMOPY_USE_CUDA)

target_link_libraries(tomo-accel PRIVATE ${TOMOPY_EXTERNAL_LIBRARIES}
                                         ${TOMOPY_EXTERNAL_PRIVATE_LIBRARIES} ptl-static)

target_compile_definitions(tomo-accel PRIVATE ${${PROJECT_NAME}_DEFINITIONS})

target_compile_options(
  tomo-accel
  PRIVATE $<$<COMPILE_LANGUAGE:C>:${${PROJECT_NAME}_C_FLAGS}>
          $<$<COMPILE_LANGUAGE:CXX>:${${PROJECT_NAME}_CXX_FLAGS}>
          $<$<COMPILE_LANGUAGE:CUDA>:${${PROJECT_NAME}_CUDA_FLAGS}>)

install(TARGETS tomo-accel EXPORT libtomoTargets)

install(
  FILES ${HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libtomo
  COMPONENT Headers)

=== source/libtomo/gridrec/CMakeLists.txt ===
set(HEADERS "${tomopy_SOURCE_DIR}/include/libtomo/filters.h"
            "${tomopy_SOURCE_DIR}/include/libtomo/gridrec.h")

if(TOMOPY_CXX_GRIDREC)
  set_source_files_properties("gridrec.c" PROPERTIES LANGUAGE CXX)
endif()

tomopy_add_library(tomo-gridrec SHARED gridrec.c pal.h ${HEADERS})

if(TOMOPY_USE_MKL)
  find_package(MKL REQUIRED)
  target_include_directories(tomo-gridrec PRIVATE ${MKL_INCLUDE_DIRS})
  target_link_options(tomo-gridrec PRIVATE
                      $<$<COMPILE_LANGUAGE:CXX>:${MKL_CXX_LINK_FLAGS}>)
  target_link_libraries(tomo-gridrec PRIVATE ${MKL_LIBRARIES})
  target_compile_definitions(tomo-gridrec PRIVATE TOMOPY_USE_MKL)
else()
  if(TOMOPY_CXX_GRIDREC)
    message(
      WARNING "TOMOPY_CXX_GRIDREC with FFTW3 is not officially supported.")
  endif()
  # FFTW doesn't officially support CMAKE, they prefer PkgConfig.
  find_package(PkgConfig REQUIRED)
  pkg_search_module(FFTW REQUIRED fftw3f IMPORTED_TARGET)
  # Must link with thread aware fftw3f in order to make planner thread safe
  target_link_libraries(tomo-gridrec PRIVATE fftw3f_threads fftw3f)
  target_compile_definitions(tomo-gridrec PRIVATE TOMOPY_USE_FFTW)
endif()

# link library to math.h
if(NOT WIN32)
  target_link_libraries(tomo-gridrec PUBLIC m)
endif()

target_include_directories(
  tomo-gridrec
  PUBLIC $<BUILD_INTERFACE:${tomopy_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE ${CMAKE_CURRENT_LIST_DIR})

target_compile_definitions(tomo-gridrec PRIVATE ${${PROJECT_NAME}_DEFINITIONS})

target_compile_options(
  tomo-gridrec PRIVATE $<$<COMPILE_LANGUAGE:C>:${${PROJECT_NAME}_C_FLAGS}>
                       $<$<COMPILE_LANGUAGE:CXX>:${${PROJECT_NAME}_CXX_FLAGS}>)

set_property(TARGET tomo-gridrec PROPERTY CXX_STANDARD 14)

install(TARGETS tomo-gridrec EXPORT libtomoTargets)

install(
  FILES ${HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libtomo
  COMPONENT Headers)

=== source/libtomo/misc/CMakeLists.txt ===
set(HEADERS
    "${tomopy_SOURCE_DIR}/include/libtomo/morph.h"
    "${tomopy_SOURCE_DIR}/include/libtomo/remove_ring.h"
    "${tomopy_SOURCE_DIR}/include/libtomo/inpainter.h"
    "${tomopy_SOURCE_DIR}/include/libtomo/median_filt3d.h")

tomopy_add_library(
  tomo-misc
  SHARED
  morph.c
  remove_ring.c
  inpainter.c
  median_filt3d.c
  ${HEADERS})

find_package(OpenMP REQUIRED COMPONENTS C)
target_link_libraries(tomo-misc PRIVATE OpenMP::OpenMP_C)
if (WIN32)
target_compile_options(
  tomo-misc PRIVATE $<$<COMPILE_LANGUAGE:C>:/openmp:experimental>)
endif()

target_include_directories(
  tomo-misc
  PUBLIC $<BUILD_INTERFACE:${tomopy_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE ${CMAKE_CURRENT_LIST_DIR})

# link library to math.h
if(NOT WIN32)
  target_link_libraries(tomo-misc PRIVATE m)
endif()

install(TARGETS tomo-misc EXPORT libtomoTargets)

install(
  FILES ${HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libtomo
  COMPONENT Headers)

=== source/libtomo/prep/CMakeLists.txt ===
set(HEADERS "${tomopy_SOURCE_DIR}/include/libtomo/prep.h"
            "${tomopy_SOURCE_DIR}/include/libtomo/stripe.h")

tomopy_add_library(
  tomo-prep
  SHARED
  prep.c
  stripe.c
  stripes_detect3d.c
  ${HEADERS})

find_package(OpenMP REQUIRED COMPONENTS C)
target_link_libraries(tomo-prep PRIVATE OpenMP::OpenMP_C)
if (WIN32)
target_compile_options(
  tomo-prep PRIVATE $<$<COMPILE_LANGUAGE:C>:/openmp:experimental>)
endif()

target_include_directories(
  tomo-prep
  PUBLIC $<BUILD_INTERFACE:${tomopy_SOURCE_DIR}/include>
         $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  PRIVATE ${CMAKE_CURRENT_LIST_DIR})

target_compile_definitions(tomo-prep PRIVATE ${${PROJECT_NAME}_DEFINITIONS})

target_compile_options(
  tomo-prep PRIVATE $<$<COMPILE_LANGUAGE:C>:${${PROJECT_NAME}_C_FLAGS}>)

set_target_properties(tomo-prep PROPERTIES
      C_STANDARD 99  # C99 or later requried for boolean type support
      C_STANDARD_REQUIRED ON)

install(TARGETS tomo-prep EXPORT libtomoTargets)

install(
  FILES ${HEADERS}
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/libtomo
  COMPONENT Headers)

=== debian/changelog ===
tomopy (1.15.2+ds1-3) unstable; urgency=medium

  * Team upload.
  * Rebuild with Python 3.13 only.

 -- Colin Watson <cjwatson@debian.org>  Sun, 09 Mar 2025 15:54:53 +0000

tomopy (1.15.2+ds1-2) unstable; urgency=medium

  * Team upload.
  * No-change upload with binaries.

 -- Colin Watson <cjwatson@debian.org>  Sun, 16 Feb 2025 14:19:43 +0000

tomopy (1.15.2+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release:
    - Fix compatibility with numpy 2.0 (closes: #1095100).

 -- Colin Watson <cjwatson@debian.org>  Fri, 14 Feb 2025 16:55:32 +0000

tomopy (1.15.0+ds1-9) unstable; urgency=medium

  * Team upload.
  * Build for all supported Python versions (closes: #1089068).

 -- Colin Watson <cjwatson@debian.org>  Fri, 13 Dec 2024 00:17:42 +0000

=== debian/control ===
Source: tomopy
Maintainer: Debian PaN Maintainers <debian-pan-maintainers@alioth-lists.debian.net>
Uploaders:
 Debian Python Team <team+python@tracker.debian.org>,
 Roland Mas <lolando@debian.org>,
Section: contrib/python
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 intel-mkl [amd64 i386],
 libfftw3-dev,
 libomp-dev [amd64 arm64 armhf ppc64 ppc64el hurd-amd64],
 libopencv-dev,
 nvidia-cuda-toolkit-gcc [amd64 arm64 ppc64el],
 pybuild-plugin-pyproject,
 python3-all,
 python3-numexpr,
 python3-numpy,
 python3-pytest,
 python3-pywt,
 python3-scipy,
 python3-setuptools,
 python3-skbuild,
 python3-skimage,
 rename,
Standards-Version: 4.5.1
Homepage: https://github.com/tomopy/tomopy
Testsuite: autopkgtest-pkg-pybuild
Vcs-Git: https://salsa.debian.org/python-team/packages/tomopy.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/tomopy

Package: python3-tomopy
Architecture: any
Depends:
 python3-numexpr,
 python3-numpy,
 python3-scipy,
 python3-skimage,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Recommends: python3-dxchange,
Description: Python package for tomographic data processing and image reconstruction
 Features:
  * Image reconstruction algorithms for tomography.
  * Various filters, ring removal algorithms, phase retrieval algorithms.
  * Forward projection operator for absorption and wave propagation.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=tomopy
include /usr/share/dpkg/architecture.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

ifneq (,$(wildcard /usr/include/mkl/mkl.h))
  USE_MKL:=ON
else
  USE_MKL:=OFF
endif

ifneq (,$(wildcard /usr/lib/llvm-*/lib/clang/*/include/omp.h))
  USE_OPENMP:=ON
else
  USE_OPENMP:=OFF
endif

export CMAKE_OPTIONS := \
  -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
  -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
  -DWITH_SHARED_LIB=1 \
  -DWITH_STATIC_LIB=0 \
  -DCMAKE_CUDA_HOST_COMPILER=cuda-g++ \
  -DMKL_ROOT_DIR=/usr \
  -DMKL_INCLUDE_DIR=/usr/include/mkl \
  -DCMAKE_BUILD_TYPE=Release \
  -DTOMOPY_USE_MKL=$(USE_MKL) \
  -DTOMOPY_USE_OPENMP=$(USE_OPENMP)

%:
	dh $@ --with python3 --buildsystem=pybuild --test-pytest

PTLLINKS=VERSION CMakeLists.txt cmake source
override_dh_auto_configure:
	mkdir -p source/PTL
	for i in $(PTLLINKS) ; do ln -s ../../PTL/$$i source/PTL/ ; done
	dh_auto_configure -Spython3 --buildsystem=pybuild -O--test-pytest
	set -e ; for v in $$(py3versions -sv) ; do \
		dh_auto_configure -Scmake -Bobj-$(DEB_HOST_GNU_TYPE)-py$$v -- $(CMAKE_OPTIONS) -DPYTHON_EXECUTABLE=/usr/bin/python$$v -DCMAKE_INSTALL_LIBDIR=/usr/lib/python$$v/dist-packages/tomopy/util/extern ; \
	done

override_dh_auto_build:
	dh_auto_build -Spython3 --buildsystem=pybuild -O--test-pytest
	set -e ; for v in $$(py3versions -sv) ; do \
		dh_auto_build -Scmake -Bobj-$(DEB_HOST_GNU_TYPE)-py$$v ; \
		dh_auto_install -Scmake -Bobj-$(DEB_HOST_GNU_TYPE)-py$$v ; \
	done

override_dh_auto_install:
	dh_auto_install -Spython3 --buildsystem=pybuild -O--test-pytest
	set -e ; for v in $$(py3versions -sv) ; do \
		dh_auto_install -Scmake -Bobj-$(DEB_HOST_GNU_TYPE)-py$$v ; \
		sed -i "s,/usr/lib/python$$v/,/usr/lib/python3/,g" debian/python3-tomopy/usr/lib/python$$v/dist-packages/tomopy/util/extern/cmake/libtomo/*.cmake ; \
	done

execute_after_dh_auto_clean:
	for i in $(PTLLINKS) ; do rm -f source/PTL/$$i ; done

execute_before_dh_auto_test:
	set -e ; for v in $$(py3versions -sv) ; do \
		cp -v debian/python3-tomopy/usr/lib/python$$v/dist-packages/tomopy/util/extern/*.so $(CURDIR)/.pybuild/cpython3_$${v}_tomopy/build/tomopy/util/extern ; \
	done

execute_after_dh_auto_test:
	rm -f $(CURDIR)/.pybuild/cpython*/build/tomopy/util/extern/*.so

## tomopy 1.15.3%2Bds1

=== debian/changelog ===
tomopy (1.15.3+ds1-3) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS on s390x with patch to use 'fork' not 'forkserver' for
    multiprocessing (Closes: #1123943).

 -- Stuart Prescott <stuart@debian.org>  Sat, 27 Dec 2025 11:40:14 +1100

tomopy (1.15.3+ds1-2) unstable; urgency=medium

  * Team upload.
  * Rebuild with Python 3.14 as a supported interpreter (Closes: #1122053).
  * Update Standards-Version to 4.7.2 (no changes required).
  * Add d/upstream/metadata.

 -- Stuart Prescott <stuart@debian.org>  Tue, 09 Dec 2025 09:17:04 +1100

tomopy (1.15.3+ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Wed, 26 Nov 2025 16:13:22 +0100

tomopy (1.15.2+ds1-4) unstable; urgency=medium

  * Bug fix: "please B-D on python3-all-dev", thanks to Graham Inggs
    (Closes: #1121432).

 -- Roland Mas <lolando@debian.org>  Wed, 26 Nov 2025 16:04:16 +0100

## tomopy 1.15.3+ds1

=== debian/control ===
--- 
+++ 
@@ -15,6 +15,7 @@
  nvidia-cuda-toolkit-gcc [amd64 arm64 ppc64el],
  pybuild-plugin-pyproject,
  python3-all,
+ python3-all-dev,
  python3-numexpr,
  python3-numpy,
  python3-pytest,
@@ -40,7 +41,8 @@
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends},
-Recommends: python3-dxchange,
+Recommends:
+ python3-dxchange,
 Description: Python package for tomographic data processing and image reconstruction
  Features:
   * Image reconstruction algorithms for tomography.

=== debian/rules ===
--- 
+++ 
@@ -59,6 +59,9 @@
 	done
 
 execute_after_dh_auto_clean:
+	set -e ; for v in $$(py3versions -sv) ; do \
+		dh_auto_clean -Scmake -Bobj-$(DEB_HOST_GNU_TYPE)-py$$v ; \
+	done
 	for i in $(PTLLINKS) ; do rm -f source/PTL/$$i ; done
 
 execute_before_dh_auto_test:
